function M = fdetect_n(I,n,Net)
% FDETECT3 face detection approach 3

MaxFaceNum = 5; MergeDiffRatio = 0.35;

[ImgHeight, ImgWidth] = size(I);
Net.threshold = 0.9;

load('av_face');
av_face = double(av_face);

if( n < 1 )
   FaceWidth = round(ImgWidth * n);
else
   FaceWidth = n;
end

BlkWidth = 20;
BlkHeight = 23;
StepLength = floor(BlkWidth / 10);

TempI = double(imresize(I,BlkWidth/FaceWidth,'nearest'));

PossibleNum = 0;

[Height, Width] = size(TempI);
for x=1:2:(Width-BlkWidth)
   for y=1:2:(Height-BlkHeight)
      % [x,y]
      % input('wait!');
      % subplot(1,2,1),subimage(imrect(I, x, y, x+BlkWidth, y+BlkWidth));
      Small = TempI(y:y+BlkHeight,x:x+BlkWidth);
      % subplot(1,2,2),subimage( imresize(uint8(I4x4), [128,128], 'nearest'));
      % input('wait!');
      k=1;
      for i=1:20
         for j=1:23
            Vector(k,1) = Small(j,i);
            k = k+1;
         end
      end
      if( strcmp(Net.mode, 'std') )
         Vector = trastd(Vector, Net.mean, Net.std);
      elseif( strcmp(Net.mode, 'pca') )
         Vector = trastd(Vector, Net.mean, Net.std);
         Vector = trapca(Vector, Net.transMat);
      end
      IsFace = sim(Net.net, Vector);
      if(IsFace > Net.threshold)
         PossibleNum = PossibleNum + 1;
         Possible(PossibleNum,1) = y;
         Possible(PossibleNum,2) = x;
      end
   end
end


Ratio = FaceWidth/BlkWidth;
HalfRatio = Ratio/2;
k=1;
for i=1:PossibleNum
   ltx(k) = floor(Possible(i,2)*Ratio - HalfRatio);
   lty(k) = floor(Possible(i,1)*Ratio - HalfRatio);
   rbx(k) = ltx(k) + FaceWidth;
   rby(k) = lty(k) + FaceWidth;
   if( ltx(k)<1 | lty(k)<1 | rbx(k)>ImgWidth | rby(k)>ImgHeight )
      ltx(k) = []; lty(k) = []; rbx(k) = []; rby(k) = [];
   else
      k = k+1;
   end
end

if(PossibleNum > 0)
   [SortLty, IndexLty] = sort(lty);
   j = 1;
   index = IndexLty(j);
   NewLty(j) = lty(index);
   NewLtx(j) = ltx(index); NewRby(j) = rby(index); NewRbx(j) = rbx(index);
   for i=2:length(lty)
      index = IndexLty(i);
      MergeDiff = MergeDiffRatio * FaceWidth;
      fprintf(1,'(%d,%d) (%d,%d) ',lty(index),ltx(index),rby(index),rbx(index));
      fprintf(1,' %d/%d, %d/%d, %d/%d, %d/%d ',floor(lty(index)-NewLty(j)),floor(MergeDiff), floor(abs(ltx(index)-NewLtx(j))),floor(MergeDiff) ,floor(abs(rby(index)-NewRby(j))),floor(MergeDiff),floor(abs(rbx(index)-NewRbx(j))),floor(MergeDiff));
      if((lty(index)-NewLty(j))>MergeDiff | abs(ltx(index)-NewLtx(j))>MergeDiff | abs(rby(index)-NewRby(j))>MergeDiff | abs(rbx(index)-NewRbx(j))>MergeDiff )
         j = j+1;
         NewLty(j) = lty(index); NewLtx(j) = ltx(index); NewRby(j) = rby(index); NewRbx(j) = rbx(index);
         fprintf(1,'Not Merge\n');
      else
         NewLty(j) = (lty(index) + NewLty(j))/2;
         NewLtx(j) = (ltx(index) + NewLtx(j))/2;
         NewRby(j) = (rby(index) + NewRby(j))/2;
         NewRbx(j) = (rbx(index) + NewRbx(j))/2;
         fprintf(1,'Merge\n');
      end
   end
   ltx = NewLtx; lty = NewLty; rbx = NewRbx; rby = NewRby;
   k = 0;
   for j=1:length(lty)
      if( ltx(j)<1 | lty(j)<1 | rbx(j)>ImgWidth | rby(j)>ImgHeight )
         
      else
         k = k+1;
         NewLtx(k) = floor(ltx(j)); NewLty(k) = floor(lty(j)); NewRbx(k) = floor(rbx(j)); NewRby(k) = floor(rby(j));
      end
   end

   for j=1:length(NewLty)
      I16x16 = double(imresize(I(NewLty(j):NewLty(j)+FaceWidth-1,NewLtx(j):NewLtx(j)+FaceWidth-1), [16,16], 'nearest'));
      Temp = abs(I16x16 - av_face) / 65536;
      MeanAbsError(j) = sum(sum(Temp(1:15,2:15)));
   end
   PossibleNum = length(NewLty);
end

if(PossibleNum > 0)
   if(PossibleNum > MaxFaceNum)
      [mValue, mY, mX] = minn(MeanAbsError,MaxFaceNum,[0,256]);
   else
      [mValue, mY, mX] = minn(MeanAbsError,PossibleNum,[0,256]);
   end
   for i=1:length(mX)
      fltx(i) = floor(NewLtx(mX(i)));
      flty(i) = floor(NewLty(mX(i)));
      frbx(i) = floor(NewRbx(mX(i)));
      frby(i) = floor(NewRby(mX(i)));
   end
   M = imrect(I, fltx,flty,frbx,frby);
   %M = imrect(K, floor(NewLtx), floor(NewLty), floor(NewRbx), floor(NewRby));
else
   M = I;
end

imshow(M);
