function M = fdetect_r(I,n,MaxFaceNum)
% FDETECT2 face detection approach 2
%   I : Image
%   if n>1, n is the number of pixels of face width
%   if n<1, n is (face width):(image width)

CenterVar = 30; UpperVar = 70; SideVar = 60; MeanDiffT=50;
EyeGrayDiff = 20; MergeDiffRatio = 0.35;

load('av_face');
av_face = double(av_face);

[ImgHeight, ImgWidth] = size(I);
if( n < 1 )
   BlkWidth = round(ImgWidth * n);
else
   BlkWidth = n;
end
StepLength = round(BlkWidth / 10);
PossibleNum = 0;
EyePairNum = 0;

xBegin = 1;
yBegin = 1;
xEnd = ImgWidth - (5/4)*BlkWidth;
yEnd = ImgHeight - (5/4)*BlkWidth;
imshow(I);
for x=xBegin:StepLength:xEnd
   for y=yBegin:StepLength:yEnd
      %[x,y]
      %input('wait!');
      %subplot(1,2,1),subimage(imrect(I, x, y, x+BlkWidth, y+BlkWidth));
      %I4x4 = imresize(I(y:y+BlkWidth,x:x+BlkWidth),[4,4],'nearest');
      I4x4 = To4x4(I,y,x,BlkWidth);
      %fprintf(1, 'Max = %d\n', max(max(I4x4)));
      %subplot(1,2,2),subimage( imresize(uint8(I4x4), [128,128], 'nearest'));
      %input('wait!');
      CenterMean = ( I4x4(2,2) + I4x4(2,3) + I4x4(3,2) + I4x4(3,3) ) / 4;
      UpperMean  = ( I4x4(1,1) + I4x4(1,2) + I4x4(1,3) + I4x4(1,4) ) / 4;
      SideMean   = ( I4x4(2,1) + I4x4(3,1) + I4x4(2,4) + I4x4(3,4) ) / 4;
      CenterDiff = (abs(I4x4(2,2)-I4x4(2,3)) + abs(I4x4(2,2)-I4x4(3,2)) + abs(I4x4(2,2)-I4x4(3,3)) + abs(I4x4(2,3)-I4x4(3,2)) + abs(I4x4(2,3)-I4x4(3,3)) + abs(I4x4(3,2)-I4x4(3,3)))/6;
      UpperDiff  = (abs(I4x4(1,1)-I4x4(1,2)) + abs(I4x4(1,1)-I4x4(1,3)) + abs(I4x4(1,1)-I4x4(1,4)) + abs(I4x4(1,2)-I4x4(1,3)) + abs(I4x4(1,2)-I4x4(1,4)) + abs(I4x4(1,3)-I4x4(1,4)))/6;
      SideDiff   = (abs(I4x4(2,1)-I4x4(3,1)) + abs(I4x4(2,1)-I4x4(2,4)) + abs(I4x4(2,1)-I4x4(3,4)) + abs(I4x4(3,1)-I4x4(2,4)) + abs(I4x4(3,1)-I4x4(3,4)) + abs(I4x4(2,4)-I4x4(3,4)))/6;
      if (CenterDiff < CenterVar & UpperDiff < UpperVar & SideDiff < SideVar & (CenterMean-UpperMean) > MeanDiffT)
         I8x8 = To8x8(I,y,x,BlkWidth);
         % Eye Rule
         EyePosition = [];
         EyeNum = 0;
         for v_lineNum=2:7
            v_line = I8x8(:,v_lineNum);
            for pixel=3:6
               if(v_line(pixel) < v_line(pixel-1) & v_line(pixel) < v_line(pixel+1))
                  if( (v_line(pixel-1)-v_line(pixel)) > EyeGrayDiff | (v_line(pixel+1)-v_line(pixel)) > EyeGrayDiff )
                     EyeNum = EyeNum + 1;
                     EyePosition(EyeNum,1) = pixel;
                     EyePosition(EyeNum,2) = v_lineNum;
                  end
               end
            end
         end
         if EyePosition 
            PairPosition = [];
            PairNum = 0;
            NumOnHLine = 0;
            for e1=1:EyeNum-1
               EyeP1y = EyePosition(e1,1);
               EyeP1x = EyePosition(e1,2);
               for e2=e1+1:EyeNum
                  EyeP2y = EyePosition(e2,1);
                  EyeP2x = EyePosition(e2,2);
                  if(abs(EyeP2y-EyeP1y) <=1 & abs(EyeP2x - EyeP1x) > 2 & abs(EyeP2x - EyeP1x) < 5)
                     PairNum = PairNum + 1;
                     PairPosition(PairNum, 1) = EyeP1y;
                     PairPosition(PairNum, 2) = EyeP1x;
                     PairPosition(PairNum, 3) = EyeP2y;
                     PairPosition(PairNum, 4) = EyeP2x;
                  end
               end
            end
            if PairPosition & PairNum < 6
               fprintf(1, 'PairNum=%d\n', PairNum);
               Ratio = BlkWidth/8;
               HalfRatio = Ratio/2;
               for i=1:PairNum
                  PairPosition(i,1) = PairPosition(i,1)*Ratio + y - HalfRatio;
                  PairPosition(i,2) = PairPosition(i,2)*Ratio + x - HalfRatio;
                  PairPosition(i,3) = PairPosition(i,3)*Ratio + y - HalfRatio;
                  PairPosition(i,4) = PairPosition(i,4)*Ratio + x - HalfRatio;
                  for j=1:4
                     fprintf(1, '  %d', PairPosition(i,j));
                  end
                  fprintf(1, '  (x,y)=(%d,%d)\n', x,y);
               end
               EyePair(EyePairNum+1:EyePairNum+PairNum,:) = PairPosition(:,:);
               EyePairNum = EyePairNum + PairNum;
               
               PossibleNum = PossibleNum + 1;
               Possible(PossibleNum, 1) = y;
               Possible(PossibleNum, 2) = x;
            end
         end
      end
   end
end
fprintf(1, '(x,y) = (%d,%d)  EyePairNum=%d\n',x,y,EyePairNum);

Ratio = BlkWidth/8;
HalfRatio = Ratio/2;
if(EyePairNum > 0)
   K = imrect(I, floor(EyePair(:,2)-HalfRatio), floor(EyePair(:,1)-HalfRatio), floor(EyePair(:,2)+HalfRatio), floor(EyePair(:,1)+HalfRatio));
   K = imrect(K, floor(EyePair(:,4)-HalfRatio), floor(EyePair(:,3)-HalfRatio), floor(EyePair(:,4)+HalfRatio), floor(EyePair(:,3)+HalfRatio));
   K = imline(K, EyePair(:,2), EyePair(:,1), EyePair(:,4), EyePair(:,3));
   j = 1;
   for i=1:EyePairNum
      [lty(j), ltx(j), rby(j), rbx(j)] = FaceRect(EyePair(i,1),EyePair(i,2),EyePair(i,3),EyePair(i,4));
      if( lty(j)>0 & ltx(j)>0 & rby(j)<ImgHeight & rbx(j)<ImgWidth )
         fwidth(j) = rbx(j) - ltx(j);
         j = j+1;
      else
         lty(j) = []; ltx(j) = []; rby(j) = []; rbx(j) = [];
      end
   end
   [SortLty, IndexLty] = sort(lty);
   j = 1;
   index = IndexLty(j);
   NewLty(j) = lty(index);
   NewLtx(j) = ltx(index); NewRby(j) = rby(index); NewRbx(j) = rbx(index); NewFWidth(j) = fwidth(index);
   for i=2:length(lty)
      index = IndexLty(i);
      MergeDiff = MergeDiffRatio * fwidth(index);
      fprintf(1,'(%d,%d) (%d,%d) ',lty(index),ltx(index),rby(index),rbx(index));
      fprintf(1,' %d/%d, %d/%d, %d/%d, %d/%d ',floor(lty(index)-NewLty(j)),floor(MergeDiff), floor(abs(ltx(index)-NewLtx(j))),floor(MergeDiff) ,floor(abs(rby(index)-NewRby(j))),floor(MergeDiff),floor(abs(rbx(index)-NewRbx(j))),floor(MergeDiff));
      if((lty(index)-NewLty(j))>MergeDiff | abs(ltx(index)-NewLtx(j))>MergeDiff | abs(rby(index)-NewRby(j))>MergeDiff | abs(rbx(index)-NewRbx(j))>MergeDiff )
         j = j+1;
         NewLty(j) = lty(index); NewLtx(j) = ltx(index); NewRby(j) = rby(index); NewRbx(j) = rbx(index);
         NewFWidth(j) = fwidth(index);
         fprintf(1,'Not Merge\n');
      else
         NewLty(j) = (lty(index) + NewLty(j))/2;
         NewLtx(j) = (ltx(index) + NewLtx(j))/2;
         NewRby(j) = (rby(index) + NewRby(j))/2;
         NewRbx(j) = (rbx(index) + NewRbx(j))/2;
         NewFWidth(j) = NewRbx(j) - NewLtx(j);
         fprintf(1,'Merge\n');
      end
   end

   for j=1:length(NewLty)
      I16x16 = To16x16(I, NewLty(j), NewLtx(j), NewFWidth(j));
      Temp = abs(I16x16 - av_face) / 65536;
      MeanAbsError(j) = sum(sum(Temp(1:15,2:15)));
   end
   EyePairNum = length(NewLty);
end

fprintf(1, 'EyePairNum = %d\n', EyePairNum);

if(EyePairNum > 0)
   if(EyePairNum > MaxFaceNum)
      [mValue, mY, mX] = minn(MeanAbsError,MaxFaceNum,[0,256]);
   else
      [mValue, mY, mX] = minn(MeanAbsError,EyePairNum,[0,256]);
   end
   for i=1:length(mX)
      fltx(i) = floor(NewLtx(mX(i)));
      flty(i) = floor(NewLty(mX(i)));
      frbx(i) = floor(NewRbx(mX(i)));
      frby(i) = floor(NewRby(mX(i)));
   end
   M = imrect(K, fltx,flty,frbx,frby);
   %M = imrect(K, floor(NewLtx), floor(NewLty), floor(NewRbx), floor(NewRby));
else
   M = I;
end

imshow(M);

function Im4x4 = To4x4(Im,y,x,Width)
% To4x4   fast than imresize(...,[4 4], 'nearest');
Ratio = Width/4;
Step = floor(Ratio);
for k=1:4
   i = round( y + (k-1)*Ratio );
   for m=1:4
      j = round( x + (m-1)*Ratio );
      Im4x4(k,m) = mean(mean(Im(i:i+Step,j:j+Step)));
   end
end

function Im8x8 = To8x8(Im,y,x,Width)
% To8x8 
Ratio = Width/8;
Step = floor(Ratio);
for k=1:8
   i = round( y + (k-1)*Ratio );
   for m=1:8
      j = round( x + (m-1)*Ratio );
      Im8x8(k,m) = mean(mean(Im(i:i+Step,j:j+Step)));
   end
end

function Im16x16 = To16x16(Im,y,x,Width)
% To16x16 
Ratio = Width/16;
Step = floor(Ratio);
for k=1:16
   i = round( y + (k-1)*Ratio );
   for m=1:16
      j = round( x + (m-1)*Ratio );
      Im16x16(k,m) = mean(mean(Im(i:i+Step,j:j+Step)));
   end
end

function [lty, ltx, rby, rbx] = FaceRect(eye1y, eye1x, eye2y, eye2x)
% FaceRect
eyeY = (eye1y + eye2y)/2;
if(eye1x > eye2x)
   temp = eye1x;
   eye1x = eye2x;
   eye2x = temp;
end
eyeWidth = eye2x - eye1x;
lty = round(eyeY - (3/8)*eyeWidth);
ltx = round(eye1x - (eyeWidth/2));
rby = round(eyeY + (13/8)*eyeWidth);
rbx = round(eye2x + (eyeWidth/2));
