function M = imline(I, p1x, p1y, p2x, p2y)
% IMLINE Draw lines on an Gray-level Image
% imline, where I is an Gray-level image matrix
%               p1x(i), p1y(i): the first point (x,y)
%               p2x(i), p2y(i): the second point (x,y)
% return M, the image matrix with lines drawed.

len = length(p1x);
for i=1:len
   if p1x(i) > p2x(i)
      px1 = round(p2x(i)); py1 = round(p2y(i));
      px2 = round(p1x(i)); py2 = round(p1y(i));
   else
      px1 = round(p1x(i)); py1 = round(p1y(i));
      px2 = round(p2x(i)); py2 = round(p2y(i));
   end
   if p1y(i) > p2y(i)
      ty1 = round(p2y(i)); tx1 = round(p2x(i));
      ty2 = round(p1y(i)); tx2 = round(p1x(i));
   else
      ty1 = round(p1y(i)); tx1 = round(p1x(i));
      ty2 = round(p2y(i)); tx2 = round(p2x(i));
   end
   h = py2 - py1;
   w = px2 - px1;
   if w ~= 0
      for p=px1:px2
         y = round((h*(p-px1)/w)+py1);
         I(y,p) = 0;
      end
   end
   h = ty2 - ty1;
   w = tx2 - tx1;
   if h ~= 0
      for t=ty1:ty2
         x = round((w*(t-ty1)/h)+tx1);
         I(t,x) = 0;
      end
   end
end
M = I;