function M = imrect(I,ltx,lty,rbx,rby)
% IMRECT Draw Rectangles on an Gray-level Image
% imrect(I), where I is an Gray-level image matrix
%                  ltx(i), lty(i): left top (x,y)
%                  rbx(i), rby(i): right bottom (x,y)
% return M, the image matrix with rectangles drawed.

len = length(ltx);
for i=1:len
   for p=ltx(i):rbx(i)
      I(lty(i),p) = 0;
      I(rby(i),p) = 0;
   end
   for p=lty(i):rby(i)
      I(p,ltx(i)) = 0;
      I(p,rbx(i)) = 0;
   end
end
M = I;